﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Reflection;

namespace SLDynLoad
{
    public partial class MainPage : UserControl
    {
        public MainPage()
        {
            InitializeComponent();
        }

        private void btnLoad_Click(object sender, RoutedEventArgs e)
        {
            btnLoad.Visibility = Visibility.Collapsed;
            txtPercent.Visibility = Visibility.Visible;
            var dnl = new WebClient();
            dnl.OpenReadCompleted += dnl_OpenReadCompleted;
            dnl.DownloadProgressChanged += dnl_DownloadProgressChanged;
            dnl.OpenReadAsync(new Uri("http://www.e-naxos.com/slsamples/sldyn/SLDynShape.dll"), UriKind.Absolute);
        }

        void dnl_DownloadProgressChanged(object sender, DownloadProgressChangedEventArgs e)
        {
            txtPercent.Text = e.ProgressPercentage + " %";
        }

        private Assembly extLib;

        void dnl_OpenReadCompleted(object sender, OpenReadCompletedEventArgs e)
        {
            txtPercent.Visibility = Visibility.Collapsed;
            try
            {
                AssemblyPart assemblyPart = new AssemblyPart();
                extLib = assemblyPart.Load(e.Result);

                var control = (UserControl) extLib.CreateInstance("SLDynShape.Strawberry");
                control.HorizontalAlignment = HorizontalAlignment.Left;
                control.VerticalAlignment = VerticalAlignment.Top;
                control.Margin = new Thickness(10, 10, 0, 0);
                gridBase.Children.Add(control);

                control = (UserControl) extLib.CreateInstance("SLDynShape.Lemon");
                control.HorizontalAlignment = HorizontalAlignment.Right;
                control.VerticalAlignment = VerticalAlignment.Bottom;
                control.Margin=new Thickness(0,0,10,40);
                gridBase.Children.Add(control);
            } catch
            {
                txtPercent.Visibility = Visibility.Visible;
                txtPercent.Text = "Failed!";
            }
        }
    }
}
